<?PHP 
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| PHP-Fusion Counter-Strike:Source monitoring panel  |
+----------------------------------------------------+
| Tested with CS:Source ver. Jun 25 2007 (3152)      |
+----------------------------------------------------+
| Ported and Modified for PHP-Fusion by Sere}l{ka
| mailto: games@mksbalashihi.ru
+----------------------------------------------------+
| Place this code into a folder under Infusions
| Make sure the folder and the filename are identical
| then add your panel. 
+----------------------------------------------------*/

include_once "settings.php";

if (!defined("IN_FUSION")) { header("Location:../../index.php"); exit; }
openside("Counter-Strike: Source");


//-----------------  -------------------//

$maps_dir = IMAGES."css_maps/";										//kelias iki paveiksliuku
$data = monitor_server_css("127.0.0.1", 27015, "halflife", "info"); // IP pakeiskite i serverio!!!!
$img =  $maps_dir.$data['mapname'].".jpg";
	
if (file_exists($img)) {} else {$img = $maps_dir."no_image.jpg";}
	
function monitor_server_css($ip, $port, $game, $request)
	{
		   $fp = @fsockopen("udp://$ip", $port, $errno, $errstr, 1);

			if (!$fp) { return FALSE; } 

			    stream_set_timeout($fp, 1, 0);
			    stream_set_blocking($fp, true);  

	 if (($request == "settings" || $request == "players"))
	 	{
	    $challenge_code = "\xFF\xFF\xFF\xFF\x57"; 
	    	fwrite($fp, $challenge_code);
	        $buffer = fread($fp, 4096);
	        if (!trim($buffer)) { fclose($fp); return FALSE; }
			$challenge_code = substr($buffer, 5, 4);
    	}

		if ($request == "info")     { $challenge = "\xFF\xFF\xFF\xFFTSource Engine Query\x00"; }
		if ($request == "players")  { $challenge = "\xFF\xFF\xFF\xFFU".$challenge_code;        }
		if ($request == "settings") { $challenge = "\xFF\xFF\xFF\xFFV".$challenge_code;        }


		    fwrite($fp, $challenge);

			$buffer = fread($fp, 4096);

		if (!$buffer) { fclose($fp); return FALSE; }     

		if ($request == "settings")
			{
		$second_packet = fread($fp, 4096);
		if (strlen($second_packet) > 0)
			{
		$reverse_check = dechex(ord($buffer[8]));      
	
		if ($reverse_check[0] == "1")
			{
		    $tmp           = $buffer;                 
		    $buffer        = $second_packet;
		    $second_packet = $tmp;
		    }

			$buffer        = substr($buffer, 13);         
		 	$second_packet = substr($second_packet, 9);   
		  	$buffer        = trim($buffer.$second_packet);
		 		}
		    	else
		   			{
		    		$buffer = trim(substr($buffer, 4)); 
		   			}
			}
		    else
		 {
		       $buffer = trim(substr($buffer, 4)); 
		    }

		        fclose($fp);

		     if (!trim($buffer)) { return FALSE; }
		   
/*--------------------   ----------------------------*/
	if ($request == "info")
		{
	  	unset($data);

		$tmp = explode("\x00", $buffer);

		 	$place = strlen($tmp[0].$tmp[1].$tmp[2].$tmp[3].$tmp[4]) + 5;
		    $data['hostname']       = $tmp[0];					//hostname
		    $data['mapname']        = $tmp[1];					//name map in server now
		    $data['gamemod']        = $tmp[2];					//name modification Half Life
			$data['Ngamemod']       = $tmp[3];					//name server
		    $data['players']     	= ord($buffer[$place + 0]);
			$data['maxplayers']  	= ord($buffer[$place + 1]);
		    $data['numbots']       	= ord($buffer[$place + 3]);	// BOTS
			$data['ip'] 			= $ip;
		    $data['server_os']      = $buffer[$place + 5];      // W indows or L inux

			return $data;  // RETURN INFO
        }

/*----------------------------------------------------------------------------------*/
	if ($request == "players")
		{
		// $buffer[0]      = datatype = D for steam players
		// ord($buffer[1]) = number of rules returned

		$player_number = 0;
		$position = 2;      											// START POINT

		do
			{
		    $player_number++;      										// INCREMENT PLAYER NUMBER
			$player[$player_number]['id'] = ord($buffer[$position]);
		    $position ++;                                               // GET PLAYER GAME ID

		    while($buffer[$position] != "\x00" && $position < 4000)     // NAME LOOP WITH 4000 CHARACTER TIMEOUT
				{
		        $player[$player_number]['name'] .= $buffer[$position];  // COLLECT PLAYER NAME
			    $position ++;
				}
			$player[$player_number]['score'] = (ord($buffer[$position + 1]))
			+ (ord($buffer[$position + 2]) * 256)
		    + (ord($buffer[$position + 3]) * 65536)
		    + (ord($buffer[$position + 4]) * 16777216);

			if ($player[$player_number]['score'] > 2147483648) { $player[$player_number]['score'] -= 4294967296; }  // NEGATIVE SCORES ( -1 )

			$time = substr($buffer, $position + 5, 4);                // PLAYER TIME IN BYTES
			if (strlen($time) < 4) { return FALSE; }                  // CHECK FOR MISSING BYTES
			list(,$time) = unpack("f", $time);                        // CONVERT BYTES TO DECIMAL
		    $time = mktime(0, 0, $time);                              // CONVERT DECIMAL TO UNIX TIMESTAMP
		    $player[$player_number]['time'] = date("H:i:s", $time);   // CONVERT TIMESTAMP TO HUMAN READABLE TIME

		    $position += 9;
		    }
		while ($position < strlen($buffer));    	                  // REPEAT UNTIL THE END OF THE BUFFER
		return $player;
		}

/*----------------------------------------------------------------------------------*/
    if ($request == "settings")
		{
		// $buffer[0]      = datatype = E for steam rules
		// ord($buffer[1]) = number of rules returned

        $tmp = substr($buffer, 2); 					 // REMOVE BEGINNING DATA BYTES
		$rawdata = explode("\x00", $tmp);

		for($i=1; $i<count($rawdata); $i=$i+2)
			{
		    $rawdata[$i] = strtolower($rawdata[$i]); // MAKE ARRAY KEYS LOWERCASE
		    $setting[$rawdata[$i]] = $rawdata[$i+1]; // LOAD DATA IN AN ARRAY
		    }

		return $setting; 							 // RETURN INFO
		}
	}

/*--------------Ives informacija apie serveri, suveskite savo serverio duomenis------------------*/   //  __  127.0.0.1  IP  !

	$server_css = "<center><img src=\"". $img ."\" width=\"160\" height=\"120\" style=\"border:1px solid #000000;\"><br>    
	IP: <b><font color=#119911>127.0.0.1:27015</font></b> <br>
	Zaideju: <b>".$data['players']."/".$data['maxplayers']."</b> <br>
	Zemlapis: <b>".$data['mapname']."</b> 

	<script language=\"JavaScript\">
	function winop_css()
	{
		winop_css = window.open(\"http://jusuwebas/infusions/css_monitoring_panel/server_players.php\",\"mywin\" ,\"height=400,width=350 ,scrollbars=yes\");
	}
	</script>

	<center>
	<a href=\"javascript:winop_css();\"><b><font color=\"red\">Kas aidia?</font></b></a>
	</center>";

/*--------------    ----------*/
echo "$server_css";
closeside();
?>